"""
    Open:FactSet Marketplace API

    This API provides read-only access to marketplace products and partners.  # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.OpenFactSetMarketplace.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.OpenFactSetMarketplace.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.OpenFactSetMarketplace.model.partner_address import PartnerAddress
    from fds.sdk.OpenFactSetMarketplace.model.partner_social_media import PartnerSocialMedia
    globals()['PartnerAddress'] = PartnerAddress
    globals()['PartnerSocialMedia'] = PartnerSocialMedia


class Partner(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('type',): {
            'CAPABILITYPARTNER': "capabilityPartner",
            'CONSULTANT': "consultant",
            'OPENFACTSETPARTNER': "openFactSetPartner",
            'DATAPARTNER': "dataPartner",
            'TECHNICALPARTNER': "technicalPartner",


        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (str,),  # noqa: E501
            'partner_page_url': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'logo': (str,),  # noqa: E501
            'short_description': (str,),  # noqa: E501
            'full_description': (str,),  # noqa: E501
            'workflow': ([str],),  # noqa: E501
            'type': (str,),  # noqa: E501
            'video_url': (str,),  # noqa: E501
            'social_media': (PartnerSocialMedia,),  # noqa: E501
            'company_url': (str,),  # noqa: E501
            'address': (PartnerAddress,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'partner_page_url': 'partnerPageUrl',  # noqa: E501
        'name': 'name',  # noqa: E501
        'logo': 'logo',  # noqa: E501
        'short_description': 'shortDescription',  # noqa: E501
        'full_description': 'fullDescription',  # noqa: E501
        'workflow': 'workflow',  # noqa: E501
        'type': 'type',  # noqa: E501
        'video_url': 'videoUrl',  # noqa: E501
        'social_media': 'socialMedia',  # noqa: E501
        'company_url': 'companyUrl',  # noqa: E501
        'address': 'address',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, partner_page_url, name, logo, short_description, full_description, workflow, type, *args, **kwargs):  # noqa: E501
        """Partner - a model defined in OpenAPI

        Args:
            id (str): Partner unique identifier, used in the request URL
            partner_page_url (str): URL of the partner's page on the partner catalog.
            name (str): Partner name
            logo (str): Partner logo URL
            short_description (str): Partner short description (plain text), appearing on the partner's card within the FactSet Partner Catalog.
            full_description (str): Partner full description (HTML)
            workflow ([str]): An array of strings describing the Partner's workflow(s), used as categories on FactSet's Partner Catalog.
            type (str): Partner type, describing the Partner's relationship with FactSet

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            video_url (str): Partner video URL. [optional]  # noqa: E501
            social_media (PartnerSocialMedia): [optional]  # noqa: E501
            company_url (str): Partner company URL. [optional]  # noqa: E501
            address (PartnerAddress): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.partner_page_url = partner_page_url
        self.name = name
        self.logo = logo
        self.short_description = short_description
        self.full_description = full_description
        self.workflow = workflow
        self.type = type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, id, partner_page_url, name, logo, short_description, full_description, workflow, type, *args, **kwargs):  # noqa: E501
        """Partner - a model defined in OpenAPI

        Args:
            id (str): Partner unique identifier, used in the request URL
            partner_page_url (str): URL of the partner's page on the partner catalog.
            name (str): Partner name
            logo (str): Partner logo URL
            short_description (str): Partner short description (plain text), appearing on the partner's card within the FactSet Partner Catalog.
            full_description (str): Partner full description (HTML)
            workflow ([str]): An array of strings describing the Partner's workflow(s), used as categories on FactSet's Partner Catalog.
            type (str): Partner type, describing the Partner's relationship with FactSet

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            video_url (str): Partner video URL. [optional]  # noqa: E501
            social_media (PartnerSocialMedia): [optional]  # noqa: E501
            company_url (str): Partner company URL. [optional]  # noqa: E501
            address (PartnerAddress): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.partner_page_url = partner_page_url
        self.name = name
        self.logo = logo
        self.short_description = short_description
        self.full_description = full_description
        self.workflow = workflow
        self.type = type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
